/********************************************************************
*																	*
*      				 Auto Generated File                            *
*                     												*		
*********************************************************************/

#ifndef __ANVDTType_H
#define __ANVDTType_H

/** include files **/
#include "atomic.h"  // class Atomic

/** declarations **/
class ANVDTType: public Atomic
{
public:
	ANVDTType( const string &name = "ANVDTType" ) ;	 // Default constructor
	~ANVDTType();					// Destructor
	virtual string className() const
		{return "ANVDTType";}

protected:
	Model &initFunction();	
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:

	/***********      Example declarations   **********************************/
	const Port &HF_Transceiver_In;	// this is an input port named 'HF_Transceiver_In'
	Port &HF_Transceiver_Out ;   	// this is an output port named 'HF_Transceiver_Out'
	const Port &HF_Status_In;	// this is an input port named 'CCU_In'
	Port &HF_Status_Out ;   	// this is an output port named 'CCU_Out'
		/**************************************************************************/

	// [(!) declare common variables]
	// Lifetime programmed since the last state transition to the next planned internal transition.
	Time sigma;
	
	// Time elapsed since the last state transition until now
	Time elapsed;
	
	// Time remaining to complete the last programmed Lifetime
	Time timeLeft;	

	// State variable to hold the present state of the Hf_Transceiver as defined in Declarations.h
	int m_StateOfHf;

	// Random number variable for probability of encryption /  decryption
	float fRandNumber;

};	// class ANVDTType

#endif   //__ANVDTType_H 
