/********************************************************************
*																	*
*      				 Auto Generated File                            *
*                     												*		
*********************************************************************/

#ifndef __Audio_MultiplexerType_H
#define __Audio_MultiplexerType_H

/** include files **/
#include "atomic.h"   // class Atomic


/** forward declarations **/
//TODO: add distribution class declaration here if needed
// Ej: class Distribution ;

/** declarations **/
class Audio_MultiplexerType: public Atomic
{
public:
	Audio_MultiplexerType( const string &name = "Audio_MultiplexerType" ) ;	 // Default constructor
	~Audio_MultiplexerType();					// Destructor
	virtual string className() const
		{return "Audio_MultiplexerType";}

protected:
	Model &initFunction();	
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	// [(!) TODO: declare ports, distributions and other private varibles here]
	/***********      Example declarations   **********************************/
	const Port &Audio_In;		// this is an input port named 'Audio_In'
	Port &Audio_Out;   			// this is an output port named 'Audio_Out'
	const Port &HF_Audio_In;	// this is an input port named 'HF_Audio_In'
	Port &HF_Audio_Out;   		// this is an output port named 'HF_Audio_Out'
	const Port &VUHF_Audio_In;	// this is an input port named 'VUHF_Audio_In'
	Port &VUHF_Audio_Out;   	// this is an output port named 'VUHF_Audio_Out'
	const Port &FM_Audio_In;	// this is an input port named 'FM_Audio_In'
	Port &FM_Audio_Out;   		// this is an output port named 'FM_Audio_Out'
	const Port &AM_Audio_In;	// this is an input port named 'AM_Audio_In'
	Port &AM_Audio_Out;   		// this is an output port named 'AM_Audio_Out'

	// Distribution *dist ;
	// Distribution &distribution()	{ return *dist; }
	/**************************************************************************/

	// [(!) declare common variables]
	// Lifetime programmed since the last state transition to the next planned internal transition.
	Time sigma;
	
	// Time elapsed since the last state transition until now
	Time elapsed;
	
	// Time remaining to complete the last programmed Lifetime
	Time timeLeft;	

	// State variable to hold the present audio state of the HF Transceiver
	int m_StateOfHf;

	// State variable to hold the present audio state of the Vuhf Transceiver
	int m_StateOfVuhf;

	// State variable to hold the present audio state of the FM Transceiver
	int m_StateOfFm;

	// State variable to hold the present audio state of the AM Transceiver
	int m_StateOfAm;

	// State variable to hold the present audio state of the Audio input
	int m_StateOfAudioIn;

	// State variable to hold the present audio state of the Audio input
	int m_StateOfAudio;

	// Array index
	int m_Index;

	// Mic keyed
	int m_StateOfMic;

};	// class Audio_MultiplexerType

#endif   //__Audio_MultiplexerType_H 
