/********************************************************************
*																	*
*      				 Auto Generated File                            *
*                     												*		
*********************************************************************/

#ifndef __CCU_InterfaceType_H
#define __CCU_InterfaceType_H

/** include files **/
#include "atomic.h"   // class Atomic

/** declarations **/
class CCU_InterfaceType: public Atomic
{
public:
	CCU_InterfaceType( const string &name = "CCU_InterfaceType" ) ;	 // Default constructor
	~CCU_InterfaceType();					// Destructor
	virtual string className() const
		{return "CCU_InterfaceType";}

protected:
	Model &initFunction();	
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	// [(!) TODO: declare ports, distributions and other private variables here]
	/***********      Example declarations   **********************************/
	const Port &Keyline_In;		// this is an input port named 'Keyline_In'
	const Port &Status_In;		// this is an input port named 'Status_In'
	const Port &CSU_In;			// this is an input port named 'CSU_In'
	const Port &Audio_In;		// this is an input port named 'Audio_In'
	const Port &Reception_In;		// this is an input port named 'Reception_In'

	Port &Status_Out;   		// this is an output port named 'Status_Out'
	Port &CSU_Out;   			// this is an output port named 'CSU_Out'
	Port &Audio_Out;   			// this is an output port named 'Audio_Out'
	Port &Reception_Out;   			// this is an output port named 'Reception_Out'
	//Distribution *dist ;
	//Distribution &distribution()	{ return *dist; }
	/**************************************************************************/

	// [(!) declare common variables]
	// Lifetime programmed since the last state transition to the next planned internal transition.
	Time sigma;
	
	// Time elapsed since the last state transition until now
	Time elapsed;
	
	// Time remaining to complete the last programmed Lifetime
	Time timeLeft;	
private:

	// State variable to hold the present state of the Control Input as defined in Declarations.h
	int m_StateOfControl;

	// State variable to hold the present state of the Status Controller as defined in Declarations.h
	int m_StateOfStatusControl;

	// State variable to hold the present state of the Keyline input as defined in Declarations.h
	int m_StateOfKeyline;

	// State variable to hold the present state of the Audio input as defined in Declarations.h
	int m_StateOfAudio;

	// State variable to hold the present state of all the radios
	int nStatus;

	// State variable to hold the count of the CSU
	int nValueCsu;

	enum State
		{         //to keep current state of the CCU logic
				Idle,       //initial state
				LedInput,
				UserInput,
				Keyed,
				Valid,
				Invalid,
				Send_Out 	//send degree at radar controller when motor1 stop
		};
		State myState;




};	// class CCU_InterfaceType




#endif   //__CCU_InterfaceType_H 
