/********************************************************************
*																	*
*      				 Auto Generated File                            *
*                     												*		
*********************************************************************/

#ifndef __CSU_Interface_ControllerType_H
#define __CSU_Interface_ControllerType_H

/** include files **/
#include "atomic.h"   // class Atomic

/** forward declarations **/
//TODO: add distribution class declaration here if needed
// Ej: class Distribution ;

/** declarations **/
class CSU_Interface_ControllerType: public Atomic
{
public:
	CSU_Interface_ControllerType( const string &name = "CSU_Interface_ControllerType" ) ;	 // Default constructor
	~CSU_Interface_ControllerType();					// Destructor
	virtual string className() const
		{return "CSU_Interface_ControllerType";}

protected:
	Model &initFunction();	
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	// [(!) TODO: declare ports, distributions and other private variables here]
	/***********      Example declarations   **********************************/
	const Port &User_Input;		// this is an input port named 'User_Input'
	const Port &Csu_In;		// this is an input port named 'Csu_In'
	const Port &Radio_Tx_In;	// this is an input port named 'Radio_Tx_In'
	const Port &Led_Status_In;	// this is an input port named 'Led_Status_In'
	Port &Status_Out;   		// this is an output port named 'Status_Out'
	Port &Button_Out;   		// this is an output port named 'Button_Out'
	Port &Gui_Out;		   		// this is an output port named 'GUI_Out'


	//Distribution *dist ;
	//Distribution &distribution()	{ return *dist; }
	/**************************************************************************/

	// [(!) declare common variables]
	// Lifetime programmed since the last state transition to the next planned internal transition.
	Time sigma;
	
	// Time elapsed since the last state transition until now
	Time elapsed;
	
	// Time remaining to complete the last programmed Lifetime
	Time timeLeft;	

	// State variable to hold the present state of the Command Button as defined in Declarations.h
	int m_StateOfCmdButton;

	// State variable to hold the present state of the Transceivers as defined in Declarations.h
	int m_StateOfRadio;

	// Array index
	int m_Index;

	// State variable to hold the present state of the LED
	int m_StateOfLed;

	enum State
	{         //to keep current state of the CSU
			Idle,       //initial state
			LedInput,
			UserInput,
			Keyed,
			Valid,
			Invalid,
			Send_Out 	//send degree at radar controller when motor1 stop
	};
	State myState;



};	// class CSU_Interface_ControllerType






#endif   //__CSU_Interface_ControllerType_H 
