/********************************************************************
*																	*
*      				 Auto Generated File                            *
*                     												*		
*********************************************************************/

#ifndef __Crypto_ControllerType_H
#define __Crypto_ControllerType_H

/** include files **/
#include "atomic.h"   // class Atomic

/** declarations **/
class Crypto_ControllerType: public Atomic
{
public:
	Crypto_ControllerType( const string &name = "Crypto_ControllerType" ) ;	 // Default constructor
	~Crypto_ControllerType();					// Destructor
	virtual string className() const
		{return "Crypto_ControllerType";}

protected:
	Model &initFunction();	
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	// [(!) TODO: declare ports, distributions and other private variables here]
	/***********      Example declarations   **********************************/
	const Port &Button_In;	// this is an input port named 'Button_In'
	Port &Gui_Out;   	// this is an output port named 'Gui_out'
	/**************************************************************************/

	// [(!) declare common variables]
	// Lifetime programmed since the last state transition to the next planned internal transition.
	Time sigma;
	
	// Time elapsed since the last state transition until now
	Time elapsed;
	
	// Time remaining to complete the last programmed Lifetime
	Time timeLeft;	

	// State variable to hold the present state of the Crypto as defined in Declarations.h
	int m_StateOfCrypto[4];

	// Array index
	int m_Index;

	enum State
	{
		//to keep current state of the crypto
		Idle,       //initial state
		Rx,    		//receiving an input from the button controller
	};
		State myState;

};	// class Crypto_ControllerType


#endif   //__Crypto_ControllerType_H
