/********************************************************************
*																	*
*      				 Auto Generated File                            *
*                     												*		
*********************************************************************/

#ifndef __GUI_ControllerType_H
#define __GUI_ControllerType_H

/** include files **/
#include "atomic.h"   // class Atomic

/** declarations **/
class GUI_ControllerType: public Atomic
{
public:
	GUI_ControllerType( const string &name = "GUI_ControllerType" ) ;	 // Default constructor
	~GUI_ControllerType();					// Destructor
	virtual string className() const
	    {return "GUI_ControllerType";}

protected:
	Model &initFunction();	
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	// [(!) TODO: declare ports, distributions and other private variables here]
	/***********      Example declarations   **********************************/
	const Port &Crypto_In;	// this is an input port named 'Crypto_In'
	const Port &Button_In;	// this is an input port named 'Button_In'
	const Port &Interface_In;	// this is an input port named 'Interface_In'
	Port &Led_Out;   	// this is an output port named 'LED_Out'

	/**************************************************************************/

	// [(!) declare common variables]
	// Lifetime programmed since the last state transition to the next planned internal transition.
	Time sigma;
	
	// Time elapsed since the last state transition until now
	Time elapsed;
	
	// Time remaining to complete the last programmed Lifetime
	Time timeLeft;	

	// State variable to hold the present state of the LED as defined in Declarations.h
	int m_StateOfLed[4];

	// State variable to hold the present state of the Crypto as defined in Declarations.h
	int m_StateOfCrypto[4];

	// Array index
	int m_Index;

	//Action to be completed
	int nAction;

	enum State{         //to keep current state of the Hf Radio
			Idle,       //initial state
			Button,    	//receiving an input from the button controller
			Crypto,		//receiving an input from the crypto controller
			Interface,	//receiving an input from the ccu interface
			Send_Out 	//send msg
		};
		State myState;


};	// class GUI_ControllerType



#endif   //__GUI_ControllerType_H 
