/********************************************************************
*																	*
*      				 Auto Generated File                            *
*                     												*		
*********************************************************************/

#ifndef __HF_TransceiverType_H
#define __HF_TransceiverType_H

/** include files **/
#include "../atomic.h"   // class Atomic

/** declarations **/
class HF_TransceiverType: public Atomic
{
public:
	HF_TransceiverType( const string &name = "HF_TransceiverType" ) ;	 // Default constructor
	~HF_TransceiverType();					// Destructor
	virtual string className() const
		{return "HF_TransceiverType";}

protected:
	Model &initFunction();	
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	// [(!) TODO: declare ports, distributions and other private varibles here]
	/***********      Example declarations   **********************************/
	const Port &ANVDT_In;	// this is an input port named 'ANVDT_In'
	Port &ANVDT_Out ;   	// this is an output port named 'ANVDT_Out'
	const Port &Audio_In;	// this is an input port named 'CCU_In'
	Port &HF_Audio_Out ;   	// this is an output port named 'CCU_Out'
	const Port &HF_Reception_In; // this is an input port named 'HF_Reception_In'
	Port &HF_Transmission_Out ;   	// this is an output port named 'HF_Transmission_Out'

	/**************************************************************************/

	// [(!) declare common variables]
	// Lifetime programmed since the last state transition to the next planned internal transition.
	Time sigma;
	
	// Time elapsed since the last state transition until now
	Time elapsed;
	
	// Time remaining to complete the last programmed Lifetime
	Time timeLeft;	

	// State variable to hold the present state of the HF Transceiver as defined in Declarations.h
	double m_StateOfHf;

	// State variable to hold the present radio activity of the Hf Transceiver as defined in Declarations.h
	double m_RadioTx;

	enum State
	{   //to keep current state of the Hf Radio
		Idle,       //initial state
		Rx,    		//receiving an input from the antenna
		Tx,			//receiving an input from the user
		Relay,		//Anvdt processed message
		Send_Out 	//send msg
	};
		State myState;


};	// class HF_TransceiverType



#endif   //__HF_TransceiverType_H 
