/********************************************************************
*																	*
*      				 Auto Generated File                            *
*                     												*		
*********************************************************************/

#ifndef __LEDType_H
#define __LEDType_H

/** include files **/
#include "../atomic.h"   // class Atomic

/** declarations **/
class LEDType: public Atomic
{
public:
	LEDType( const string &name = "LEDType" ) ;	 // Default constructor
	~LEDType();					// Destructor
	virtual string className() const
		{return "LEDType";}

protected:
	Model &initFunction();	
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	// [(!) TODO: declare ports, distributions and other private variables here]
	/***********      Example declarations   **********************************/
	const Port &Gui_In;	// this is an input port named 'GUI_In'
	Port &Led_Status_Out ;   	// this is an output port named 'Led_Status_Out'
	/**************************************************************************/

	// [(!) declare common variables]
	// Lifetime programmed since the last state transition to the next planned internal transition.
	Time sigma;
	
	// Time elapsed since the last state transition until now
	Time elapsed;
	
	// Time remaining to complete the last programmed Lifetime
	Time timeLeft;

	// State variable to hold the present state of the LED as defined in Declarations.h
	int m_StateOfLed;

	// Colour variable to hold the present colour of the LED as defined in Declarations.h
	int m_OldStateOfLed;

};	// class LEDType


#endif   //__LEDType_H 
