/********************************************************************
*																	*
*      				 Auto Generated File                            *
*                     												*		
*********************************************************************/

#ifndef __Status_ControllerType_H
#define __Status_ControllerType_H

/** include files **/
#include "atomic.h"   // class Atomic

/** forward declarations **/
//TODO: add distribution class declaration here if needed
// Ej: class Distribution ;

/** declarations **/
class Status_ControllerType: public Atomic
{
public:
	Status_ControllerType( const string &name = "Status_ControllerType" ) ;	 // Default constructor
	~Status_ControllerType();					// Destructor
	virtual string className() const
		{return "Status_ControllerType";}

protected:
	Model &initFunction();	
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	// [(!) TODO: declare ports, distributions and other private varibles here]
	/***********      Example declarations   **********************************/
	const Port &Interface_In;	// this is an input port named 'Interface_In'
	const Port &ANVDT_In;		// this is an input port named 'ANVDT_In'
	Port &Interface_Out;   		// this is an output port named 'Interface_Out'
	Port &ANVDT_Out;   			// this is an output port named 'ANVDT_Out'
	//Distribution *dist ;
	//Distribution &distribution()	{ return *dist; }
	/**************************************************************************/

	// [(!) declare common variables]
	// Lifetime programmed since the last state transition to the next planned internal transition.
	Time sigma;
	
	// Time elapsed since the last state transition until now
	Time elapsed;
	
	// Time remaining to complete the last programmed Lifetime
	Time timeLeft;	

	// State variable to hold the present state of the ANVDT as defined in Declarations.h
	int m_AnvdtState;

	// State variable to hold the present state of the radios as defined in Declarations.h
	int m_RadioState;





};	// class Status_ControllerType




#endif   //__Status_ControllerType_H 
