/*******************************************************************
*
*  Auto Generated File
*
*  DESCRIPTION: Simulator::registerNewAtomics()
*
*  This registration file is used to describe the atomic models that can be used to compose coupled models.
*
*
*******************************************************************/

#include "../modeladm.h"
#include "../mainsimu.h"
#include "../queue.h"      // class Queue
#include "../generat.h"    // class Generator
#include "../cpu.h"        // class CPU
#include "../transduc.h"   // class Transducer
#include "../trafico.h"    // class Trafico
#include "../models/ggad/ggad.h"       // DEVS-Graphs interpreter
#include "CSU_Interface_ControllerType.h"	// class CSU_Interface_ControllerType
#include "Button_ControllerType.h"	// class Button_ControllerType
#include "Crypto_ControllerType.h"	// class Crypto_ControllerType
#include "GUI_ControllerType.h"	// class GUI_ControllerType
#include "LEDType.h"	// class LEDType
#include "Audio_MultiplexerType.h"	// class Audio_MultiplexerType
#include "Status_ControllerType.h"	// class Status_ControllerType
#include "CCU_InterfaceType.h"        // class CCU_InterfaceType
#include "HF_TransceiverType.h"	// class HF_TransceiverType
#include "ANVDTType.h"	// class ANVDTType


void MainSimulator::registerNewAtomics()
{
	// Register Built-in models
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Queue>() , "Queue" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Generator>() , "Generator" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<CPU>() , "CPU" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Transducer>() , "Transducer" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Trafico>() , "Trafico" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Ggad>() , "Ggad" ) ; // DEVS-GRAPHS interpreter

	// Register custom models
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<CSU_Interface_ControllerType>() , "CSU_Interface_ControllerType" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Button_ControllerType>() , "Button_ControllerType" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Crypto_ControllerType>() , "Crypto_ControllerType" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<GUI_ControllerType>() , "GUI_ControllerType" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<LEDType>() , "LEDType" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Audio_MultiplexerType>() , "Audio_MultiplexerType" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Status_ControllerType>() , "Status_ControllerType" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<CCU_InterfaceType>(), "CCU_InterfaceType" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<HF_TransceiverType>() , "HF_TransceiverType" ) ;
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<ANVDTType>() , "ANVDTType" ) ;

}
